###############################################################################
# EventCalReminder.pm                                                         #
# $Date: 12.01.14 $                                                           #
###############################################################################
# YaBB: Yet another Bulletin Board                                            #
# Open-Source Community Software for Webmasters                               #
# Version:        YaBB 2.7.00                                                 #
# Distributed by: http://www.yabbforum.com                                    #
# =========================================================================== #
# Copyright (c) 2000-2017 YaBB (www.yabbforum.com) - All Rights Reserved.     #
# Software by:  The YaBB Development Team                                     #
#               with assistance from the YaBB community.                      #
###############################################################################
use strict;
use warnings;
use CGI::Carp qw(fatalsToBrowser);
our $VERSION = '2.7.00';

our $eventcalreminderpmver = 'YaBB 2.7.0 $Revision: 1 $';

our ($action);
$action ||= q{};
if ( $action eq 'detailedversion' ) { return 1; }

our (
    $date,            $enabletz,             $forum_default,
    $iamguest,        $mycalout_bd_reminder, $scripturl,
    $show_colorlinks, $show_event_cal,       $showage,
    $timeselected,    $uid,                  $username,
    %bith_rem,        %croak,                %format_unbold,
    %link,            %useraccount,          %var_cal,
);

if ( !$show_event_cal || $show_event_cal == 0 ) {
    load_language('EventCal');
    get_template('Calendar');
}

my $cal_remimg = 'eventcal.png';

sub get_calbd_reminder {

    my $heute = $date;
    my $toffs = 0;
    if ($enabletz) {
        $toffs = toffs($date);
    }

    my ( $sec, $min, $hour, $mday, $mon, $year, $wday, $yday, $dst ) =
      gmtime( $heute + $toffs );
    $year += 1900;
    $mon = $mon + 1;
    my $actualmon = $mon;
    my $actualday = $mday;
    if ( $actualmon < 10 ) { $actualmon = "0$actualmon"; }
    if ( $actualday < 10 ) { $actualday = "0$actualday"; }

    my ($mytimeselected);
    {
        no strict qw(refs);
        $mytimeselected =
          ( $forum_default || !${ $uid . $username }{'timeselect'} )
          ? $timeselected
          : ${ $uid . $username }{'timeselect'};
    }

    our (%calbday);
    if ( -e 'Variables/Eventcalbday.pm' ) {
        require Variables::Eventcalbday;
    }
    my $bToday     = 0;
    my $bTomorrow  = 0;
    my $bYesterday = 0;
    my @gettday    = ();
    my @gettom     = ();
    my @getyest    = ();
    foreach my $user_bdname ( keys %calbday ) {
        my ( $user_bdyear, $user_bdmon, $user_bdday, $user_bdhide ) =
          @{ $calbday{$user_bdname} };
        my $rem_y = $year;
        my $age   = $rem_y - $user_bdyear;
        if ( $actualday == $user_bdday && $actualmon == $user_bdmon ) {
            $bToday++;
            push @gettday, getlinks( $user_bdname, $user_bdhide, $age );
        }

        if ( $user_bdday == $actualday + 1 && $actualmon == $user_bdmon ) {
            $bTomorrow++;
            push @gettom, getlinks( $user_bdname, $user_bdhide, $age );
        }

        if ( $user_bdday == $actualday - 1 && $actualmon == $user_bdmon ) {
            $bYesterday++;
            push @getyest, getlinks( $user_bdname, $user_bdhide, $age );
        }

    }

    my $Todays_Birthdays = $bith_rem{'none'};
    if ( $bToday > 0 ) {
        $Todays_Birthdays = join q~, ~, @gettday;
    }
    my $Tomorrows_Birthdays = $bith_rem{'none'};
    if ( $bTomorrow > 0 ) {
        $Tomorrows_Birthdays = join q~, ~, @gettom;
    }
    my $Yesterdays_Birthdays = $bith_rem{'none'};
    if ( $bYesterday > 0 ) {
        $Yesterdays_Birthdays = join q~, ~, @getyest;
    }
    my $bith_rem_intro = q{};
    if ( !$iamguest ) {
        $bith_rem_intro = qq~$bith_rem{'intro'}<br />$bith_rem{'notes'}~;
    }
    else {
        $bith_rem_intro = $bith_rem{'intro'};
    }

    my $my_bd_reminder = $mycalout_bd_reminder;
    $my_bd_reminder =~ s/\Q{yabb remimg}\E/$cal_remimg/xsm;
    $my_bd_reminder =~ s/\Q{yabb bith_rem_intro}\E/$bith_rem_intro/xsm;
    $my_bd_reminder =~ s/\Q{yabb todays_birthdays}\E/$Todays_Birthdays/xsm;
    $my_bd_reminder =~ s/\Q{yabb tomorrows_birthdays}\E/$Tomorrows_Birthdays/xsm;
    $my_bd_reminder =~ s/\Q{yabb yesterdays_birthdays}\E/$Yesterdays_Birthdays/xsm;

    return $my_bd_reminder;
}

sub getlinks {
    my ( $user_bdname, $user_bdhide, $age ) = @_;
    my $user_linkprofile = q{};
    if ($show_colorlinks) {
        load_user($user_bdname);
        $user_linkprofile = $link{$user_bdname};
    }
    else {
        load_user($user_bdname);
        $user_linkprofile =
qq~<a href="$scripturl?action=viewprofile;username=$useraccount{$user_bdname}" rel="nofollow">$format_unbold{$user_bdname}</a>~;
    }
    my $myage = $age;
    if   ( $showage && $user_bdhide ) { $myage = q{}; }
    else                              { $myage = qq~ ($age)~; }
    $user_linkprofile = qq~$user_linkprofile$myage~;
    return $user_linkprofile;
}

1;
